## libdrm 2.3.1-3

=== debian/changelog ===
libdrm (2.3.1-3) unstable; urgency=low

  * Added lintian overrides
  * Build fixes

 -- Grigori Timonen <grigori.timonen@nokia.com>  Thu,  6 Nov 2008 15:03:29 +0200

libdrm (2.3.1-2) unstable; urgency=high

  * Remove from the source package a bunch of files that are only used by the
    kernel drm component.  This gets rid of the mga, r128 and radeon
    microcode, and thus closes: #502675.  Thanks, Ben Hutchings!

 -- Julien Cristau <jcristau@debian.org>  Sun, 19 Oct 2008 14:26:37 +0200

libdrm (2.3.1-1) unstable; urgency=low

  [ Brice Goglin ]
  * Update upstream URL in debian/copyright.
  * Bump Standards-Version to 3.7.3 (no changes).
  * Drop the XS- prefix from Vcs-Git and Vcs-Browser fields in debian/control.
  * Install the upstream ChangeLog.

  [ Julien Cristau ]
  * New upstream release (needed for mesa 7.1 and newer xserver).
  * Note: this release removes the memory manager (TTM) interface used by the
    i915tex dri driver.
  * debian/rules: don't call configure with --host if we're not
    cross-building, and fix some rules dependencies.

  [ Timo Aaltonen ]
  * Bump the shlibs to 2.3.1.

 -- Julien Cristau <jcristau@debian.org>  Sun, 13 Jul 2008 19:07:49 +0200

libdrm (2.3.0-4) unstable; urgency=low

  [ David Nusinow ]
  * Add NEWS.Debian explaining the change in the last upload to interested
    administrators.

  [ Julien Cristau ]
  * Upload to unstable.

 -- Julien Cristau <jcristau@debian.org>  Fri, 20 Apr 2007 05:06:34 +0200

libdrm (2.3.0-3) experimental; urgency=low

  * Add myself to uploaders
  * Patch libdrm to default to device permission 666 so we don't have to do it
    in xorg.conf. The only way libdrm can do anything is through the server
    anyway. This can still be overridden by a user's xorg.conf. This change
    also requires adding quilt to the build-depends

 -- David Nusinow <dnusinow@debian.org>  Sun, 15 Apr 2007 13:08:50 -0400

libdrm (2.3.0-2) unstable; urgency=low

  * Update my email address in debian/control.
  * Add XS-Vcs-Git and XS-Vcs-Browser in debian/control.
  * Upload to unstable.

 -- Julien Cristau <jcristau@debian.org>  Thu, 12 Apr 2007 19:06:57 +0200

libdrm (2.3.0-1) experimental; urgency=low

  [ Thierry Reding ]
  * New upstream release.
  * Set the Debian X Strike Force as maintainer.
  * Add myself to uploaders.
  * Add a debugging symbol package for libdrm2.

  [ Julien Cristau ]
  * Bump shlibs to libdrm2 >= 2.3.0.
  * Add myself to uploaders.
  * Add build-dep on dpkg-dev >= 1.13.19 to make sure that the binary:Version
    substvar is available.
  * libdrm2-dbg depends on libdrm2 (= ${binary:Version}).
  * Don't install libdrm.la, and use dh_install --list-missing.

 -- Julien Cristau <julien.cristau@ens-lyon.org>  Thu,  4 Jan 2007 18:56:08 +0100

libdrm (2.2.0-0.1) experimental; urgency=low

  * Non-maintainer upload.
  * New upstream release.
  * Bump Standards-Version to 3.7.2, no changes required.
  * Bump debhelper compatibility to 5 and adjust build-dependency.
  * Don't try to install pkgconfig files from usr/share/pkgconfig because
    there is nothing in that directory.

 -- Thierry Reding <thierry@gilfi.de>  Sat, 18 Nov 2006 19:50:26 +0100

libdrm (2.0.2-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release (closes: #377166).
    - Includes a fix for FTBFS on GNU/kFreeBSD (closes: #332994).
  * Manually force static build.

 -- Andres Salomon <dilinger@debian.org>  Sat, 23 Sep 2006 06:32:23 +0000

libdrm (2.0.1-1) unstable; urgency=high

  * New upstream release
    - Fixes a pathological hash table smash discovered by the Coverity scanner
    - updates the installed header files for various new #defines

 -- David Nusinow <dnusinow@debian.org>  Tue,  4 Apr 2006 23:46:05 -0400

libdrm (2.0-1) experimental; urgency=low

  * First upload to Debian

 -- David Nusinow <dnusinow@debian.org>  Thu,  5 Jan 2006 22:45:27 -0500

libdrm (2.0-0ubuntu1) dapper; urgency=low

  * New upstream release.
  * Change binary package from libdrm1 to libdrm2, following soversion bump.

 -- Daniel Stone <daniel.stone@ubuntu.com>  Mon, 12 Dec 2005 13:05:22 +1100

libdrm (1.0.5-0ubuntu1) dapper; urgency=low

  * New upstream version.

 -- Daniel Stone <daniel.stone@ubuntu.com>  Wed,  2 Nov 2005 01:56:07 +1100

libdrm (1.0.3-3) unstable; urgency=low

  * Yay for understandable bug reports! *gmprf*
  * debian/control:libdrm1 =~ s/development/runtime/ (closes: bug#325515)

 -- Marcelo E. Magallon <mmagallo@debian.org>  Fri, 16 Sep 2005 09:46:05 -0600

libdrm (1.0.3-2) unstable; urgency=low

  * libdrm.pc.in: add -ldrm to Libs

 -- Marcelo E. Magallon <mmagallo@debian.org>  Thu, 08 Sep 2005 20:49:01 -0600

libdrm (1.0.3-1) unstable; urgency=low

  * New upstream

 -- Marcelo E. Magallon <mmagallo@debian.org>  Sun, 28 Aug 2005 11:12:07 -0600

libdrm (1.0.2-3) unstable; urgency=low

  * debian/control: it's "Direct Rendering Infraestructure".  I was rather
    sure it stand for interface... thanks Michel.  (closes: bug#324514)
  * debian/control: forgot to actually write this in the file.  Build-Depends
    on libx11-dev.  Thanks Kurt (closes: bug#324560)

 -- Marcelo E. Magallon <mmagallo@debian.org>  Sun, 28 Aug 2005 11:01:41 -0600

libdrm (1.0.2-2) unstable; urgency=low

  * Forgot to fix the other broken bit :-P

 -- Marcelo E. Magallon <mmagallo@debian.org>  Fri, 19 Aug 2005 22:01:32 -0600

libdrm (1.0.2-1) unstable; urgency=low

  * Initial release. Closes: #324074

 -- Marcelo E. Magallon <mmagallo@debian.org>  Fri, 19 Aug 2005 21:11:18 -0600
