=== debian/watch ===
version=3

http://dri.freedesktop.org/libdrm/libdrm-(.*)\.tar\.gz
